/*
	
	Solitaire.cpp
	
	by Chris Page
	
*/

#ifndef _ALERT_H
#include <Alert.h>
#endif

#ifndef SOLITAIRE_WINDOW_H
#include "SolitaireWindow.h"
#endif

#ifndef SOLITAIRE_H
#include "Solitaire.h"
#endif


main()
{
	DB_TRACE("main");
	
	SolitaireApplication *application = new SolitaireApplication();
	application->Run();
	delete application;
	
	return(0);
}


SolitaireApplication::SolitaireApplication()
		  		  : BApplication('SLTR')
{
	DB_TRACE("SolitaireApplication::SolitaireApplication");
	
	this->happyHappyJoyJoy = FALSE;
	
	// Create a new window, centered on the main screen.
	const float cSolitaireWindowWidth = 470;
	const float cSolitaireWindowHeight = 450;
	
	screen_info aScreenInfo;
	get_screen_info(&aScreenInfo);
	
	BPoint aLeftTop((aScreenInfo.frame.Width() - cSolitaireWindowWidth) / 2,
				(aScreenInfo.frame.Height() - cSolitaireWindowHeight) / 2);
	BPoint aWidthHeight(cSolitaireWindowWidth, cSolitaireWindowHeight);
	BRect aRect(aLeftTop, aLeftTop + aWidthHeight);
	
	// Make sure it doesn't cover the dock.
	float aDockWidth;
	get_dock_width(&aDockWidth);
	const float cMinLeft = aDockWidth + 3;
	if (aRect.left < cMinLeft)
		aRect.OffsetBy(cMinLeft - aRect.left, 0);
	
	// Make sure the window tab is on screen.
	const float cMinTop = aScreenInfo.frame.top + 25;
	if (aRect.top < cMinTop)
		aRect.OffsetBy(0, cMinTop - aRect.top);
	
	SolitaireWindow *window = new SolitaireWindow(aRect);
	
	// Make window visible.
	window->Show();
}


// Display About Box.

void SolitaireApplication::AboutRequested()
{
	this->happyHappyJoyJoy = !this->happyHappyJoyJoy;
	
	BAlert *alert = new BAlert(NULL,
		"...by Chris Page\n"
		"\n"
		"Simple, free...what more could you ask for?\n"
		"\n"
		"Thanks to: Renaud Boisjoly (Arby) for Solo Deluxe;"
		" John Pavley for video-animated cards"
		" (to be included in version 1.1, honest);"
		" Jeff Songster for insisting on double-clicking;"
		" John Turner for pointing out a major flaw at the"
		" last minute.\n"
		"\n"
		"Hints: You can double-click cards;"
		" You can split columns, but it is considered cheating;"
		" There is no undo--think before you click.",
		this->happyHappyJoyJoy ? "Happy! Happy!" : "Joy! Joy!",
		NULL, NULL, B_WIDTH_FROM_LABEL);
	(void) alert->Go();
}
