/*
	DebugUtils.cpp
	
	by Chris Page
	
	Debugging utilities.
*/

#ifndef DEBUG_UTILS_H
#include "DebugUtils.h"
#endif

#ifndef __stdio__
#include <stdio.h>
#endif


#if DEBUG

// Initialize class members.

int DebugTrace::depth = 0;


void debug_trace(int depth, char *procedure_name)
{
	while (depth-- > 0)
		printf("..");
	printf("%s()\n", procedure_name);
	fflush(stdout);
}


// Print the procedure name and increment the depth.

DebugTrace::DebugTrace(char *procedure_name)
{
	debug_trace(depth, procedure_name);
	depth++;
}


// Decrement the depth.

DebugTrace::~DebugTrace()
{
	depth--;
}

#endif
