/*
	
	CardModel.h
	
	by Chris Page
	
*/

#ifndef CARD_MODEL_H
#define CARD_MODEL_H

#ifndef SUPPORT_DEFS_H
#include <SupportDefs.h>
#endif

class CardModel {
	
public:
	
	// Local types
	
	typedef enum {
		cHearts,
		cClubs,
		cDiamonds,
		cSpades
	} Suit;
	
	// Card rank is in the range 1 through 13, where 1 is Ace and
	// 11 through 13 are Jack, Queen, and King, respectively.
	typedef int	Rank;
	
	// Data members
	
	Suit	suit;
	Rank	rank;
	
	// Function members
	
			CardModel(Suit suit, Rank rank);
				
	bool	IsSameColor(CardModel *card2);
};

#endif
