/*
	
	ColumnModel.h
	
	by Chris Page
	
*/

#ifndef COLUMN_MODEL_H
#define COLUMN_MODEL_H

#ifndef LIST_H
#include <List.h>
#endif


class CardModel;

class ColumnModel {
	
	// Data members
	
	BList	*faceDownCards;
	BList	*faceUpCards;
	
public:
	
	// Function members
	
				ColumnModel();
	virtual		~ColumnModel();
	
	void		Add(CardModel *card);
	void		Add(BList *cards);
	void		AddFaceDown(CardModel *card);
	BList		*Remove(CardModel *card);

	CardModel	*Bottom() const;
	CardModel	*CardFaceUpAt(long index) const;
	bool		HasFaceUp(CardModel *card) const;
	bool		AllFaceUp() const;
	
	bool		IsEmpty() const;
	long		Count() const;
	long		CountFaceDown() const;
	long		CountFaceUp() const;

	void		TurnBottomFaceUp();
};

#endif
