/*
	
	FoundationModel.cpp
	
	by Chris Page
	
*/

#ifndef CARD_MODEL_H
#include "CardModel.h"
#endif

#ifndef FOUNDATION_MODEL_H
#include "FoundationModel.h"
#endif


// Create an empty foundation.

FoundationModel::FoundationModel()
{
	DB_TRACE("FoundationModel::FoundationModel");
	
	this->cards = new BList(14);
}


// Delete all the cards in the foundation.

FoundationModel::~FoundationModel()
{
	DB_TRACE("FoundationModel::~FoundationModel");
	
	while (!this->cards->IsEmpty())
		delete (CardModel*) this->cards->RemoveItem(0L);
	delete this->cards;
}


// Add a face-up card to the top of the foundation. Returns self.

FoundationModel *FoundationModel::Add(CardModel *card)
{
	DB_TRACE("FoundationModel::Add");
	
	this->cards->AddItem(card);
	
	return this;
}


// Return the top card of the foundation. This does not remove the card
// from the foundation.

CardModel *FoundationModel::Top() const
{
	DB_TRACE("FoundationModel::Top");
	
	return (CardModel*) this->cards->LastItem();
}


// Return the specified card. This does not remove the card.

CardModel *FoundationModel::CardAt(long index) const
{
	DB_TRACE("FoundationModel::CardAt");
	
	return (CardModel*) this->cards->ItemAt(index);
}


// Return TRUE if the foundation is empty.

bool FoundationModel::IsEmpty() const
{
	DB_TRACE("FoundationModel::IsEmpty");
	
	return this->cards->IsEmpty();
}


// Return the number of cards in the foundation.

long FoundationModel::Count() const
{
	DB_TRACE("FoundationModel::Count");
	
	return this->cards->CountItems();
}
