/*
	
	SolitaireModel.h
	
	by Chris Page
	
*/

#ifndef SOLITAIRE_MODEL_H
#define SOLITAIRE_MODEL_H

#ifndef _SUPPORT_DEFS_H
#include <SupportDefs.h>
#endif


class CardModel;
class DeckModel;
class HandModel;
class ColumnModel;
class FoundationModel;


class SolitaireModel {
	
public:
	
	enum {
		cColumnCount = 7,
		cFoundationCount = 4
	};
	
	// Data members
	
	DeckModel		*deck;
	HandModel		*hand;
	ColumnModel		*columns[cColumnCount];
	FoundationModel	*foundations[cFoundationCount];
	
	// Function members
	
			SolitaireModel();
	virtual	~SolitaireModel();
	
	bool	Won() const;
	
	void	DealHand();
	
	bool	IsMovable(CardModel *card) const;
	bool	IsMovable(CardModel *card, ColumnModel *toColumn) const;
	bool	IsMovable(CardModel *card,
					  FoundationModel *toFoundation) const;
	
	void	Move(CardModel *card, ColumnModel *toColumn);
	void	Move(CardModel *card, FoundationModel *toFoundation);
};

#endif
