/*
	
	CardView.h
	
	by Chris Page
	
*/

#ifndef CARD_VIEW_H
#define CARD_VIEW_H

#ifndef RECT_H
#include <Rect.h>
#endif


class BView;
class CardModel;

class CardView {
	
	// Data members.
	
	BView		*view;
	BRect		frame;
	CardModel	*card;
	bool		faceUp;
	
public:
	
	enum {
		cCardWidth = 60,
		cCardHeight = 75,
		cCardRadius = 8
	};
	
	// Function members.
	
				CardView(BView* view, BRect frame,
						 CardModel* card, bool faceUp = FALSE);
				CardView(BView* view, BRect frame);
				
	void		Draw(BRect updateRect);
	BRect		Frame() const;
	void		SetFrame(BRect frame);

	CardModel	*Model() const;
	void		SetModel(CardModel* card);
	bool		FaceUp() const;
	void		SetFaceUp(bool faceUp);

private:

	void		DrawFront();
	void		DrawBack();
};

#endif
