/*
	
	ColumnView.h
	
	by Chris Page
	
*/

#ifndef COLUMN_VIEW_H
#define COLUMN_VIEW_H

#ifndef _VIEW_H
#include <View.h>
#endif


class SolitaireView;
class BList;
class CardView;
class ColumnModel;

class ColumnView : public BView {
	
	// Data members.
	
public:
	
	enum {
		cCardCount = 13,
		cCardFaceDownCount = 6,
		cCardCountAll = cCardCount + cCardFaceDownCount,
		cCardFaceDownOffset = 3,
		cCardFaceUpOffset = 15
	};
	
private:
	
	SolitaireView	*solitaireView;
	ColumnModel		*column;
	CardView		*cardViews[cCardCountAll];
	bool			hilited;
	BRect			hiliteRect;
	
	long			oldCardCount;
	
public:
	
	// Function members.
	
					ColumnView(BRect frame,
							   SolitaireView *solitaireView,
							   ColumnModel *column);
	virtual			~ColumnView();
	
	virtual void	AttachedToWindow();
	virtual	void	Draw(BRect updateRect);
	virtual void	MouseDown(BPoint point);
	
	virtual void	MouseMoved(BPoint point, ulong transit,
							   BMessage *message);
	virtual bool	MessageDropped(BMessage *message, BPoint point,
								   BPoint offset);
	
	void			ModelChanged();
	
private:
	
	void			Hilite(bool hilited);
	
	CardModel		*AcceptCardMessage(BMessage *message) const;
};

#endif
