/*
	
	DeckView.h
	
	by Chris Page
	
*/

#ifndef DECK_VIEW_H
#define DECK_VIEW_H

#ifndef _VIEW_H
#include <View.h>
#endif


class SolitaireView;
class CardView;
class DeckModel;

class DeckView : public BView {
	
public:
	
	// Data members.
	
	enum {
		cCardViewCount = 3
	};
	
private:
	
	SolitaireView	*solitaireView;
	DeckModel		*deck;
	CardView		*cardViews[cCardViewCount];
	bool			hilited;
	
	int				oldDisplayedCardCount;
	bool			oldIsEmpty;
	
public:
	
	// Function members.
	
					DeckView(BRect frame,
							 SolitaireView* solitaireView,
							 DeckModel* deck);
	virtual			~DeckView();
	
	virtual void	AttachedToWindow();
	virtual	void	Draw(BRect updateRect);
	
	virtual void	MouseDown(BPoint point);
	
			void	ModelChanged();
	
private:
	
	void			Hilite(bool hilited);
};

#endif
