/*
	
	FoundationView.h
	
	by Chris Page
	
*/

#ifndef FOUNDATION_VIEW_H
#define FOUNDATION_VIEW_H

#ifndef _VIEW_H
#include <View.h>
#endif


class SolitaireView;
class CardView;
class FoundationModel;

class FoundationView : public BView {
	
public:
	
	// Data members.
	
	enum {
		cCardViewCount = 3
	};
	
private:
	
	SolitaireView	*solitaireView;
	CardView		*cardViews[cCardViewCount];
	bool			hilited;
	
public:
	
	FoundationModel	*foundation;
	
	// Function members.
	
					FoundationView(BRect frame,
								   SolitaireView *solitaireView,
								   FoundationModel *foundation);
	virtual			~FoundationView();
	
	virtual void	AttachedToWindow();
	virtual	void	Draw(BRect updateRect);
	
	virtual void	MouseMoved(BPoint point, ulong transit,
							   BMessage *message);
	virtual bool	MessageDropped(BMessage *message, BPoint point,
								   BPoint offset);
	
	void			ModelChanged();
	
private:
	
	void			Hilite(bool hilited);
	
	CardModel		*AcceptCardMessage(BMessage *message) const;
};

#endif
