/*
	
	HandView.h
	
	by Chris Page
	
*/

#ifndef HAND_VIEW_H
#define HAND_VIEW_H

#ifndef _VIEW_H
#include <View.h>
#endif

#ifndef HAND_MODEL_H
#include "HandModel.h"
#endif


class SolitaireView;
class CardView;

class HandView : public BView {
	
	// Data members.
	
public:
	
	enum {
		cCardOffset = 16
	};
	
private:
	
	SolitaireView	*solitaireView;
	HandModel		*hand;
	CardView		*cardViews[HandModel::cCardCount];
	bool			hilited;
	
public:
	
	// Function members.
	
					HandView(BRect frame,
							 SolitaireView *solitaireView,
							 HandModel *hand);
	virtual			~HandView();
					
	virtual void	AttachedToWindow();
	virtual void	Draw(BRect rect);
	virtual void	MouseDown(BPoint point);
	
	void			ModelChanged();
	
private:
	
	void			Hilite(bool hilited);
};

#endif
