/*
	
	SolitaireView.h
	
	by Chris Page
	
*/

#ifndef SOLITAIRE_VIEW_H
#define SOLITAIRE_VIEW_H

#ifndef _VIEW_H
#include <View.h>
#endif

#ifndef SOLITAIRE_MODEL_H
#include "SolitaireModel.h"
#endif


class DeckView;
class HandView;
class ColumnView;
class FoundationView;

class SolitaireView : public BView {
	
	// Friends. These classes currently need access to some of the
	// other views and models. To do this right, either they should
	// get the references they need passed to them, or there should
	// be SolitaireView functions that provide higher-level access
	// to the functions they need to call.
	
	friend class DeckView;
	friend class HandView;
	friend class ColumnView;
	friend class FoundationView;
	
	// Data members.
	
	enum {
		cMargin = 2,
		cColumnOffset = 3,
		cFoundationOffset = 3,
		cHandOffset = 16
	};
	
	SolitaireModel	*solitaire;
	DeckView		*deckView;
	HandView		*handView;
	ColumnView		*columnViews[SolitaireModel::cColumnCount];
	FoundationView	*foundationViews[SolitaireModel::cFoundationCount];
	
public:
	
	enum {
		cViewColorRed = 0,
		cViewColorGreen = 160,
		cViewColorBlue = 0
	};
	
	// Function members.
	
					SolitaireView(BRect frame, SolitaireModel* solitaire);
					
	virtual	void	AttachedToWindow();
	
			void	ModelChanged();
};

#endif
